## pyside6 6.10.2

=== sources/pyside6/doc/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.18)
cmake_policy(VERSION 3.18)

project(doc)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../../shiboken6/cmake")
include(FindDocTools)

# When the doc project is built as part of the pyside project, we show informational message
# and return early if requirements are not met.
if(NOT CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    if(QT_SRC_DIR AND SPHINX_BUILD AND DOT_EXEC AND BUILD_DOCS)
        # All requirements met, proceed.
    else()
        set(reasons "")
        if(NOT QT_SRC_DIR)
            list(APPEND reasons "    QT_SRC_DIR variable not set\n")
        endif()
        if(NOT SPHINX_BUILD)
            list(APPEND reasons "    sphinx-build command not found\n")
        endif()
        if(NOT DOT_EXEC)
            list(APPEND reasons "    graphviz not found\n")
        endif()
        if(NOT BUILD_DOCS)
            list(APPEND reasons "    BUILD_DOCS was set to FALSE (default)\n")
        endif()
        message(STATUS "apidoc generation targets disabled due to the following reasons:\n"
                ${reasons})
        return()
    endif()
else()
    # We are building the docs as a standalone project, likely via setup.py build_base_docs
    # command. Perform stricter sanity checks.
    if(NOT SPHINX_BUILD)
        message(FATAL_ERROR "sphinx-build command not found. Please set the SPHINX_BUILD variable.")
    endif()
endif()

# Generate html by default.
if(NOT DOC_OUTPUT_FORMAT)
    set(DOC_OUTPUT_FORMAT "html")
endif()

if (WIN32)
    set(PATH_SEP "\;")
else()
    set(PATH_SEP ":")
endif()

set(DOC_DATA_DIR "${CMAKE_CURRENT_BINARY_DIR}/qdoc-output")
# Directory for sphinx-generated files to build the HTML website. If changed,
# update "build_scripts/main.py" in "PysideBaseDocs" class at line:
# self.sphinx_src = self.out_dir / "base".
set(DOC_BASE_DIR "base")

set(ENV_INHERITANCE_FILE "${CMAKE_CURRENT_BINARY_DIR}/inheritance.json")

get_filename_component(ROOT ${CMAKE_CURRENT_BINARY_DIR} DIRECTORY)
set(TS_ROOT "${ROOT}/PySide6")

file(REMOVE ${CMAKE_CURRENT_LIST_DIR}/pyside.qdocconf ${CMAKE_CURRENT_LIST_DIR}/pyside.qdocconf.in)

# We need to find the interpreter when running this only
# for the 'build_base_docs' case, and not a full doc build
if (NOT FULLDOCSBUILD)
    find_package(Python COMPONENTS Interpreter)
endif()

if (QT_SRC_DIR)
    file(REAL_PATH ${QT_SRC_DIR}/.. QT_ROOT_PATH)
else()
    set(QT_ROOT_PATH "")
endif()

if(PYSIDE_IS_CROSS_BUILD)
    set(python_executable "${QFP_PYTHON_HOST_PATH}")
else()
    set(python_executable "${Python_EXECUTABLE}")
endif()

set(TOOLS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../../tools")

if (FULLDOCSBUILD)
    # Fetch and transform the snippets from Qt
    set(SNIPPETS_TOOL "${TOOLS_DIR}/snippets_translate/main.py")
    set(SNIPPETS_TARGET ${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/codesnippets)

    # Note QT_SRC_DIR points to 'qtbase',
    # so we use the general SRC directory to copy all the other snippets
    add_custom_target("snippets_translate" DEPENDS "${SNIPPETS_TARGET}")
    add_custom_command(OUTPUT "${SNIPPETS_TARGET}"
                       COMMAND ${python_executable} ${SNIPPETS_TOOL}
                               --qt ${QT_ROOT_PATH} --target ${SNIPPETS_TARGET} -w
                       WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                       COMMENT "Fetching and converting snippets...")
endif()

# Generate example gallery
set(EXAMPLE_TOOL_TARGET "${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/examples")
set(EXAMPLE_TOOL_OPTIONS --target "${EXAMPLE_TOOL_TARGET}" --qt-src-dir "${QT_SRC_DIR}")
if (QUIET_BUILD)
    list(APPEND EXAMPLE_TOOL_OPTIONS "-q")
endif()
set(EXAMPLE_TOOL_DIR "${TOOLS_DIR}/example_gallery/main.py")

add_custom_target("example_gallery" DEPENDS "${EXAMPLE_TOOL_TARGET}")
add_custom_command(OUTPUT "${EXAMPLE_TOOL_TARGET}"
                   COMMAND ${python_executable} ${EXAMPLE_TOOL_DIR} ${EXAMPLE_TOOL_OPTIONS}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                   COMMENT "Generating example gallery...")

# Generate the release notes
set(RELEASED_NOTES_TARGET "${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/release_notes")
set(RELEASE_NOTES_OPTIONS --target "${RELEASED_NOTES_TARGET}")
set(RELEASE_NOTES_TOOL "${TOOLS_DIR}/release_notes/main.py")
if (NOT QUIET_BUILD)
    list(APPEND RELEASE_NOTES_OPTIONS "-v")
endif()

add_custom_target("release_notes" DEPENDS "${RELEASED_NOTES_TARGET}")
add_custom_command(OUTPUT "${RELEASED_NOTES_TARGET}"
                   COMMAND ${python_executable} ${RELEASE_NOTES_TOOL} ${RELEASE_NOTES_OPTIONS}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                   COMMENT "Generating release notes...")

set(SHIBOKEN_INTERSPHINX_FILE "${ROOT}/pyside6/shiboken6/objects.inv")
set(HAS_WEBENGINE_WIDGETS 0)
set(SKIP_SPHINX_WARNINGS 1)
if (FULLDOCSBUILD)
    set(SKIP_SPHINX_WARNINGS 0)
    set(SHIBOKEN_INTERSPHINX_FILE "${CMAKE_BINARY_DIR}/doc/html/shiboken6/objects.inv")
    # For Qt modules that are part of the documentation build:
    #    - Configure the module docconf file
    #    - Write shiboken header consisting of pyside6_global.h and module includes
    #    - Build include path for qdoc for shiboken

    # The last element of the include list is the mkspec directory containing qplatformdefs.h
    list(GET Qt${QT_MAJOR_VERSION}Core_INCLUDE_DIRS -1 mkspecInclude)
    set(config_docconf "${CMAKE_CURRENT_LIST_DIR}/pyside-config.qdocconf")
    configure_file("pyside-config.qdocconf.in" "${config_docconf}" @ONLY)

    set(global_header "${pyside6_BINARY_DIR}/qdoc.h")
    file(READ "${CMAKE_CURRENT_LIST_DIR}/../PySide6/pyside6_global.h" docHeaderContents)
    file(WRITE ${global_header} "${docHeaderContents}")

    set(global_typesystem "${CMAKE_CURRENT_BINARY_DIR}/typesystem_doc.xml")
    file(READ "typesystem_doc.xml.in" typeSystemDocXmlContents)
    file(WRITE ${global_typesystem} "${typeSystemDocXmlContents}")

    execute_process(
      COMMAND ${Python_EXECUTABLE} "${TOOLS_DIR}/doc_modules.py"
              -t "${global_typesystem}" -g "${global_header}" -d "${config_docconf}"
              "${QT_INCLUDE_DIR}" "${SUPPORTED_QT_VERSION}"
      OUTPUT_VARIABLE ALL_DOC_MODULES
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    separate_arguments (ALL_DOC_MODULES UNIX_COMMAND "${ALL_DOC_MODULES}")

    foreach(moduleIn ${ALL_DOC_MODULES})
        string(TOLOWER "${moduleIn}" lowerModuleIn)
        set(docConf "${CMAKE_CURRENT_LIST_DIR}/qtmodules/pyside-qt${lowerModuleIn}.qdocconf.in")
        if(EXISTS "${docConf}")
            string(REGEX REPLACE "(^.*)\.in" "\\1" OUTFILE ${docConf})
            get_filename_component(BASENAME ${OUTFILE} NAME)
            configure_file(${docConf} "${CMAKE_CURRENT_LIST_DIR}/qtmodules/${BASENAME}" @ONLY)
            file(APPEND "pyside.qdocconf.in" "\@CMAKE_CURRENT_LIST_DIR\@/qtmodules/${BASENAME}\n")
        endif()
    endforeach()

    # There is no binding for the qtdoc repository, but it has some relevant documents.
    set(qtdoc_doc_conf "qtmodules/pyside-qtdoc.qdocconf")
    configure_file("${qtdoc_doc_conf}.in" "${CMAKE_CURRENT_LIST_DIR}/${qtdoc_doc_conf}" @ONLY)
    file(APPEND "pyside.qdocconf.in" "\@CMAKE_CURRENT_LIST_DIR\@/${qtdoc_doc_conf}\n")

    configure_file("pyside.qdocconf.in" "pyside.qdocconf" @ONLY)
    configure_file("qdoc_spawner.py.in" "qdoc_spawner.py" @ONLY)


    set(QDOC_TYPESYSTEM_PATH "${pyside6_SOURCE_DIR}${PATH_SEP}${pyside6_BINARY_DIR}")

    if(NOT qdoc_binary)
        message(FATAL_ERROR
                "No qdoc binary was found which full documentation generation requires. "
                "Please either add qdoc to PATH or specify the QDOC_EXECUTABLE variable."
        )
    endif()

    add_custom_target(qdoc DEPENDS "${DOC_DATA_DIR}/webxml/qtcore-index.webxml")

    add_custom_command(OUTPUT "${DOC_DATA_DIR}/webxml/qtcore-index.webxml"
                        Use dummy Qt version information, QDoc needs it but has no effect on WebXML output
                       COMMAND ${CMAKE_COMMAND} -E env ${python_executable} qdoc_spawner.py
                           --qt=${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}
                           --doc-data-dir=${DOC_DATA_DIR}
                           --qdoc-binary=${qdoc_binary}
                           --build-dir=${CMAKE_CURRENT_LIST_DIR}/src
                           --qt-install-docs=${QT_SRC_DIR}/doc
                           --parallel="auto"
                           --verbose
                       COMMENT "Running qdoc against Qt source code...")
endif()

# Avoid using 'auto' for '-j' option as it could lead to
# crash on some systems due to out-of-memory situation. Instead
# use a no. less than 8.
add_custom_target(apidoc
                  COMMAND ${CMAKE_COMMAND} -E env INHERITANCE_FILE=${ENV_INHERITANCE_FILE}
                          ${SHIBOKEN_PYTHON_INTERPRETER} ${SPHINX_BUILD} -b ${DOC_OUTPUT_FORMAT}
                          -j 6 ${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR} html
                  COMMENT "Generating PySide htmls..."
                 )

# create a custom commands to copy the shiboken docs
# and generate offline help based on the output format.
if(DOC_OUTPUT_FORMAT STREQUAL "html")
    add_custom_command(TARGET apidoc POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/html/shiboken6
            COMMAND ${CMAKE_COMMAND} -E copy_directory
                    ${CMAKE_CURRENT_BINARY_DIR}/../../shiboken6/doc/html
                    ${CMAKE_CURRENT_BINARY_DIR}/html/shiboken6
            COMMENT "Copying Shiboken docs..."
            VERBATIM)
else()
    if(qhelpgenerator_binary)
        message(STATUS "qhelpgenerator - found")
        # Python script that will be called to update the QHP
        set(PATCH_QHP_SCRIPT "${CMAKE_CURRENT_LIST_DIR}/../../shiboken6/doc/scripts/patch_qhp.py")
        file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/html/PySide.qhp QHP_FILE)
        add_custom_command(TARGET apidoc POST_BUILD
                COMMAND ${python_executable} ${PATCH_QHP_SCRIPT} -p -v pyside6 ${QHP_FILE}
                COMMAND "${qhelpgenerator_binary}" ${QHP_FILE}
                COMMENT "Generating QCH from a QHP file..."
                VERBATIM
        )
    else()
        message(WARNING "qhelpgenerator - not found! qch generation disabled")
    endif()
endif()

# create conf.py based on conf.py.in
configure_file("conf.py.in" "${DOC_BASE_DIR}/conf.py" @ONLY)

set(CODE_SNIPPET_ROOT "${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/codesnippets")

if (FULLDOCSBUILD)
shiboken_get_tool_shell_wrapper(shiboken tool_wrapper)

set(RHI_INCLUDE_DIR ${QT_INCLUDE_DIR}/QtGui/${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}/QtGui)

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/PySide6/QtCore/index.rst"
                   COMMAND
                       ${tool_wrapper}
                       $<TARGET_FILE:Shiboken6::shiboken6>
                       --generator-set=qtdoc
                       ${global_header}
                       --enable-pyside-extensions
                       --include-paths="${QT_INCLUDE_DIR}${PATH_SEP}${RHI_INCLUDE_DIR}${PATH_SEP}${pyside6_SOURCE_DIR}${PATH_SEP}${TS_ROOT}"
                       --api-version=${SUPPORTED_QT_VERSION}
                       --typesystem-paths="${QDOC_TYPESYSTEM_PATH}"
                       --library-source-dir=${QT_SRC_DIR}
                       --documentation-data-dir=${DOC_DATA_DIR}
                       --output-directory=${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}
                       --documentation-code-snippets-dir=${CODE_SNIPPET_ROOT}
                       --snippets-path-rewrite=${QT_ROOT_PATH}:${CODE_SNIPPET_ROOT}
                       --documentation-extra-sections-dir=${CMAKE_CURRENT_BINARY_DIR}/${DOC_BASE_DIR}/extras

=== sources/pyside6/libpyside/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

project(libpyside)

find_package(Qt6 COMPONENTS Core CorePrivate)

set(libpyside_libraries Qt::Core Qt::CorePrivate)

set(CMAKE_AUTOMOC ON)

set(libpyside_HEADERS # installed below
    class_property.h
    dynamicqmetaobject.h
    dynamicslot_p.h
    feature_select.h
    pysideclassdecorator_p.h
    pysideclassinfo.h
    pysideclassinfo_p.h
    pysidecleanup.h
    pyside.h
    pysideinit.h
    pysidelogging_p.h
    pysidemacros.h
    pysidemetafunction.h
    pysidemetafunction_p.h
    pysidemetatype.h
    pyside_numpy.h
    pyside_p.h
    pysideproperty.h
    pysideproperty_p.h
    pysideqapp.h
    pysideqenum.h
    pysideqhash.h
    pysideqmetatype.h
    pysideqobject.h
    pysideqslotobject_p.h
    pysidesignal.h
    pysidesignal_p.h
    pysideslot_p.h
    pysidestaticstrings.h
    pysideutils.h
    pysidevariantutils.h
    pysideweakref.h
    qobjectconnect.h
    signalmanager.h
)

set(libpyside_SRC
    class_property.cpp
    dynamicqmetaobject.cpp
    dynamicslot.cpp
    feature_select.cpp
    signalmanager.cpp
    pysideclassdecorator.cpp
    pysideclassinfo.cpp
    pysideqenum.cpp
    pysideqslotobject_p.cpp
    pysidemetafunction.cpp
    pysidesignal.cpp
    pysideslot.cpp
    pysideproperty.cpp
    pysidevariantutils.cpp
    pysideweakref.cpp
    pyside.cpp
    pyside_numpy.cpp
    pysidestaticstrings.cpp
    qobjectconnect.cpp
    ${libpyside_HEADERS}
)

qt6_add_resources(libpyside_SRC libpyside.qrc)

# Add python files to project explorer in Qt Creator, when opening the CMakeLists.txt as a project,
# so you can look up python files with the Locator.
macro(add_other_files)
     foreach(_it ${ARGN})
         if(NOT IS_DIRECTORY ${_it})
             get_filename_component(name ${_it} NAME)
             if(NOT ${_it} MATCHES "^/\\\\..*$;~$")
                 set_source_files_properties(${_it} PROPERTIES HEADER_FILE_ONLY TRUE)
             endif()
         endif()
     endforeach()
endmacro()

# Test files.
file(GLOB_RECURSE pyside_folder_py_files "../*.py")

# Mostly for setup.py.
file(GLOB setup_folder_py_files "../../../*.py")

set(other_files ${pyside_folder_py_files} ${setup_folder_py_files})
add_other_files(${other_files})

add_library(pyside6 SHARED ${libpyside_SRC} ${other_files})
add_library(PySide6::pyside6 ALIAS pyside6)

#does nothing if QFP_NO_OVERRIDE_OPTIMIZATION_FLAGS (no-size-optimization) flag is not set
append_size_optimization_flags(pyside6)

target_include_directories(pyside6 PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:PySide6/include>
)

target_compile_definitions(pyside6 PRIVATE -DQT_LEAN_HEADERS=1 -DQT_NO_KEYWORDS=1)

target_link_libraries(pyside6
                      PRIVATE Shiboken6::libshiboken ${libpyside_libraries})

set_target_properties(pyside6 PROPERTIES
                      VERSION ${BINDING_API_VERSION}
                      SOVERSION "${PYSIDE_SO_VERSION}"
                      OUTPUT_NAME "pyside6${pyside6_SUFFIX}${SHIBOKEN_PYTHON_SHARED_LIBRARY_SUFFIX}"
                      DEFINE_SYMBOL BUILD_LIBPYSIDE)

set_property(TARGET pyside6 PROPERTY CXX_STANDARD 17)

if(PYSIDE_QT_CONF_PREFIX)
    set_property(SOURCE pyside.cpp
                 APPEND
                 PROPERTY COMPILE_DEFINITIONS
                 PYSIDE_QT_CONF_PREFIX=${PYSIDE_QT_CONF_PREFIX})
endif()

#
# install stuff
#

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(LIBRARY_OUTPUT_SUFFIX ${CMAKE_DEBUG_POSTFIX})
else()
    set(LIBRARY_OUTPUT_SUFFIX ${CMAKE_RELEASE_POSTFIX})
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D QT_NO_CAST_FROM_ASCII -D QT_NO_CAST_TO_ASCII")

qfp_strip_library("pyside6")

# create pkg-config file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pyside6.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/pyside6${pyside6_SUFFIX}.pc" @ONLY)

# for creating cmake-config files
include(CMakePackageConfigHelpers)

# Build-tree / super project package config file.
set(PYSIDE_PYTHONPATH "${PYTHON_SITE_PACKAGES}/PySide6")
set(PYSIDE_TYPESYSTEMS "${CMAKE_INSTALL_PREFIX}/share/PySide6${pyside6_SUFFIX}/typesystems")
set(PYSIDE_GLUE "${CMAKE_INSTALL_PREFIX}/share/PySide6${pyside6_SUFFIX}/glue")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/PySide6Config-spec.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/PySide6Config${SHIBOKEN_PYTHON_CONFIG_SUFFIX}.cmake"
    INSTALL_DESTINATION "${CMAKE_CURRENT_BINARY_DIR}"
    PATH_VARS PYSIDE_PYTHONPATH PYSIDE_TYPESYSTEMS PYSIDE_GLUE
    INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}"
)

# Install-tree / wheel configuration
set(PYSIDE_PYTHONPATH "")
set(PYSIDE_TYPESYSTEMS "typesystems")
set(PYSIDE_GLUE "glue")
set(PYSIDE_SOVERSION "${pyside6_library_so_version}")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/PySide6Config-spec.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/install/PySide6Config${SHIBOKEN_PYTHON_CONFIG_SUFFIX}.cmake"
    INSTALL_DESTINATION "${LIB_INSTALL_DIR}/cmake/PySide6"
    PATH_VARS PYSIDE_PYTHONPATH PYSIDE_TYPESYSTEMS PYSIDE_GLUE
)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/PySide6Config.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/PySide6Config.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/PySide6ConfigVersion.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/PySide6ConfigVersion.cmake" @ONLY)

install(FILES ${libpyside_HEADERS}
        DESTINATION ${BINDING_NAME}${pyside6_SUFFIX}/include)

# build-time installation
install(TARGETS pyside6 EXPORT PySide6Targets
                        LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                        ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
                        RUNTIME DESTINATION bin)

# wheel installation
set_target_properties(pyside6 PROPERTIES
    VERSION ${PYSIDE_SOVERSION})

if(NOT is_pyside6_superproject_build)
    install(TARGETS pyside6 EXPORT PySide6WheelTargets
                            LIBRARY DESTINATION "PySide6"
                            ARCHIVE DESTINATION "PySide6"
                            RUNTIME DESTINATION "PySide6")
endif()

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pyside6${pyside6_SUFFIX}.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/PySide6Config.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/PySide6")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/install/PySide6Config${SHIBOKEN_PYTHON_CONFIG_SUFFIX}.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/PySide6")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/PySide6ConfigVersion.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/PySide6")

=== sources/shiboken6/libshiboken/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

project(libshiboken)

option(ENABLE_VERSION_SUFFIX "Used to use current version in suffix to generated files. This is used to allow multiples versions installed simultaneous." FALSE)
if(ENABLE_VERSION_SUFFIX)
    set(shiboken6_SUFFIX "-${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}")
else()
    set(shiboken6_SUFFIX "")
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sbkversion.h.in"
               "${CMAKE_CURRENT_BINARY_DIR}/sbkversion.h" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/embed/signature_bootstrap.py"
               "${CMAKE_CURRENT_BINARY_DIR}/embed/signature_bootstrap.py" @ONLY)

# Variable from enclosing scope.
list(TRANSFORM shiboken_python_files
     PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/../shibokenmodule/files.dir/shibokensupport/"
     OUTPUT_VARIABLE embedded_shiboken_files)

if (QUIET_BUILD)
    set(embedding_option "--quiet")
else()
    set(embedding_option "")
endif()

if(SHIBOKEN_IS_CROSS_BUILD)
    set(host_python_path "${QFP_PYTHON_HOST_PATH}")
    set(use_pyc_in_embedding FALSE)
else()
    set(host_python_path "${Python_EXECUTABLE}")
    if(PYTHON_LIMITED_API)
        set(use_pyc_in_embedding FALSE)
    else()
        set(use_pyc_in_embedding TRUE)
    endif()
endif()

add_custom_command(
    OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/embed/signature_bootstrap_inc.h"
    OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/embed/signature_inc.h"
    COMMAND ${host_python_path} -E
            "${CMAKE_CURRENT_SOURCE_DIR}/embed/embedding_generator.py"
            --cmake-dir "${CMAKE_CURRENT_BINARY_DIR}/embed"
            --use-pyc ${use_pyc_in_embedding}
            ${embedding_option}
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/embed/embedding_generator.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/embed/signature_bootstrap.py"
            ${embedded_shiboken_files}
    )

set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
set(libshiboken_SOVERSION "${shiboken6_library_so_version}")

set(libshiboken_SRC
autodecref.h
basewrapper.cpp basewrapper.h basewrapper_p.h
bindingmanager.cpp bindingmanager.h
bufferprocs_py37.cpp bufferprocs_py37.h
debugfreehook.cpp debugfreehook.h
gilstate.cpp gilstate.h
helper.cpp helper.h
pep384impl.cpp pep384impl.h
pyobjectholder.h
sbkarrayconverter.cpp sbkarrayconverter.h sbkarrayconverter_p.h
sbkbindingutils.cpp sbkbindingutils.h
sbkcontainer.cpp sbkcontainer.h
sbkconverter.cpp sbkconverter.h sbkconverter_p.h
sbkcppstring.cpp sbkcppstring.h sbkcpptonumpy.h
sbkenum.cpp sbkenum.h
sbkerrors.cpp sbkerrors.h
sbkfeature_base.cpp sbkfeature_base.h
sbkmodule.cpp sbkmodule.h sbkmodule_p.h
sbknumpy.cpp sbknumpycheck.h
sbknumpyview.h
sbkpep.h
sbkpepbuffer.h
sbkpython.h
sbksmartpointer.cpp sbksmartpointer.h
sbkstaticstrings.cpp sbkstaticstrings.h sbkstaticstrings_p.h
sbkstring.cpp sbkstring.h
sbktypefactory.cpp sbktypefactory.h
sbkwindows.h
shiboken.h
shibokenbuffer.cpp shibokenbuffer.h
shibokenmacros.h
threadstatesaver.cpp threadstatesaver.h
voidptr.cpp voidptr.h

embed/signature_bootstrap_inc.h
embed/signature_inc.h

signature/signature.cpp signature.h signature_p.h
signature/signature_globals.cpp
signature/signature_extend.cpp
signature/signature_helper.cpp
)

# This is needed to let the header obey a variable in "pep384impl.h".
# Note: This must be set on the cpp file!
set_property(SOURCE "pep384impl.cpp" PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)

add_library(libshiboken SHARED ${libshiboken_SRC})
add_library(Shiboken6::libshiboken ALIAS libshiboken)

target_include_directories(libshiboken PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:shiboken6/include>
)

if (NOT "${NUMPY_INCLUDE_DIR}" STREQUAL "")
    message(STATUS "NUMPY_INCLUDE_DIR: " ${NUMPY_INCLUDE_DIR})
    target_include_directories(libshiboken PRIVATE ${NUMPY_INCLUDE_DIR})
    target_compile_definitions(libshiboken PRIVATE -DHAVE_NUMPY
                                           PRIVATE -DNPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION)
else()
    message(STATUS "NUMPY not found")
endif()

if(SHIBOKEN_IS_CROSS_BUILD)
    target_compile_definitions(libshiboken PRIVATE -DSHIBOKEN_NO_EMBEDDING_PYC=1)
endif()

shiboken_compute_python_includes()
# On Windows we need to link against the python.lib import library.
# On macOS and Linux we don't link against the python shared / static library,
# the dynamic linker will pick up the python symbols at runtime automatically.
shiboken_compute_python_libraries()

if(PYTHON_LIMITED_API)
    target_compile_definitions(libshiboken PUBLIC "-DPy_LIMITED_API=0x03090000")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    if(PYTHON_WITH_DEBUG)
        target_compile_definitions(libshiboken PUBLIC "-DPy_DEBUG")
    endif()
    if (PYTHON_WITH_COUNT_ALLOCS)
        target_compile_definitions(libshiboken PUBLIC "-DCOUNT_ALLOCS")
    endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(libshiboken PUBLIC "-DNDEBUG")
endif()

set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken6${shiboken6_SUFFIX}${PYTHON_SHARED_LIBRARY_SUFFIX}"
                                             VERSION ${libshiboken_VERSION}
                                             SOVERSION ${libshiboken_SOVERSION}
                                             DEFINE_SYMBOL BUILD_LIBSHIBOKEN)

qfp_strip_library("libshiboken")

install(FILES
        autodecref.h
        basewrapper.h
        basewrapper_p.h
        bindingmanager.h
        gilstate.h
        helper.h
        pyobjectholder.h
        sbkarrayconverter.h
        sbkbindingutils.h
        sbkcontainer.h
        sbkconverter.h
        sbkcpptonumpy.h
        sbkenum.h
        sbkerrors.h
        sbkfeature_base.h
        sbkmodule.h
        sbkmodule_p.h
        sbknumpycheck.h
        sbknumpyview.h
        sbkstring.h
        sbkcppstring.h
        sbksmartpointer.h
        sbkstaticstrings.h
        sbktypefactory.h
        shiboken.h
        shibokenmacros.h
        threadstatesaver.h
        shibokenbuffer.h
        sbkpep.h
        sbkpepbuffer.h
        sbkpython.h
        sbkwindows.h
        pep384impl.h
        pep384ext.h
        voidptr.h
        bufferprocs_py37.h
        "${CMAKE_CURRENT_BINARY_DIR}/sbkversion.h"

        signature.h
        signature_p.h

        DESTINATION shiboken6${shiboken6_SUFFIX}/include)
install(TARGETS libshiboken EXPORT Shiboken6Targets
                            LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                            ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
                            RUNTIME DESTINATION bin)
install(EXPORT Shiboken6Targets NAMESPACE Shiboken6::
        DESTINATION ${LIB_INSTALL_DIR}/cmake/Shiboken6)

# wheel specific installation
if(NOT is_pyside6_superproject_build)

    set_target_properties(libshiboken PROPERTIES
        VERSION ${libshiboken_SOVERSION})

    install(TARGETS libshiboken EXPORT Shiboken6WheelTargets
            LIBRARY DESTINATION "shiboken6"
            ARCHIVE DESTINATION "shiboken6"
            RUNTIME DESTINATION "shiboken6")

    install(EXPORT Shiboken6WheelTargets
            NAMESPACE Shiboken6::
            DESTINATION "${LIB_INSTALL_DIR}/wheels/cmake/Shiboken6"
            FILE Shiboken6Targets.cmake)
endif()

=== sources/shiboken6/tests/minimalbinding/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

project(minimal)

set(minimal_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_minimal.xml
)

set(minimal_SRC
${CMAKE_CURRENT_BINARY_DIR}/minimal/minimal_module_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/containeruser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/obj_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/val_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/listuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/spanuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/minbooluser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/invisiblenamespace_visiblenamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/minimal/invisiblenamespace_visiblenamespace_valuetype_wrapper.cpp
)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/minimal-binding.txt.in"
               "${CMAKE_CURRENT_BINARY_DIR}/minimal-binding.txt" @ONLY)

shiboken_get_tool_shell_wrapper(shiboken tool_wrapper)
if(SHIBOKEN_UNOPTIMIZE)
    SET(UNOPTIMIZE "--unoptimize=${SHIBOKEN_UNOPTIMIZE}")
ENDIF()

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/mjb_rejected_classes.log"
    BYPRODUCTS ${minimal_SRC}
    COMMAND
        ${tool_wrapper}
        $<TARGET_FILE:Shiboken6::shiboken6>
        --project-file=${CMAKE_CURRENT_BINARY_DIR}/minimal-binding.txt
        ${UNOPTIMIZE}
        ${GENERATOR_EXTRA_FLAGS}
    DEPENDS ${minimal_TYPESYSTEM} ${CMAKE_CURRENT_SOURCE_DIR}/global.h Shiboken6::shiboken6
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Running generator for 'minimal' test binding..."
)

add_library(minimal MODULE ${minimal_SRC})
target_include_directories(minimal PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(minimal PUBLIC libminimal libshiboken)
set_property(TARGET minimal PROPERTY PREFIX "")
set_property(TARGET minimal PROPERTY OUTPUT_NAME "minimal${PYTHON_EXTENSION_SUFFIX}")
if(WIN32)
    set_property(TARGET minimal PROPERTY SUFFIX ".pyd")
endif()

create_generator_target(minimal)

=== debian/changelog ===
pyside6 (6.10.2-2ubuntu1) resolute; urgency=medium

  * Skip new tools man page generation that times out on riscv64.

 -- Rik Mills <rikmills@kde.org>  Mon, 16 Feb 2026 21:02:14 +0000

pyside6 (6.10.2-2) experimental; urgency=medium

  * Remove all __pycache__ cleanly to prevent FTBFS on buildd.

 -- Stuart Prescott <stuart@debian.org>  Mon, 16 Feb 2026 22:02:56 +1100

pyside6 (6.10.2-1) experimental; urgency=medium

  * New upstream release.
    - includes support for Qt 6.10 (Closes: #1127921)
    - rename packages to match
    - rebase patches
  * Add compatibility symlinks for tools (Closes: #1114822).
  * Drop unneeded Priority:optional and R3:no fields.
  * Update Standards-Version to 4.7.3 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Mon, 16 Feb 2026 18:55:25 +1100

=== debian/control ===
Source: pyside6
Section: python
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders:
 Kurt Kremitzki <kkremitzki@debian.org>,
 Stuart Prescott <stuart@debian.org>,
Build-Depends:
 chrpath,
 clang,
 cmake (>= 3.1),
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 dh-sequence-sphinxdoc,
 furo <!nodoc>,
 help2man,
 libclang-dev,
 libxml2-dev,
 libxslt1-dev,
 llvm-dev,
 ninja-build,
 patchelf,
 python3-dev,
 python3-distro,
 python3-numpy,
 python3-opengl,
 python3-packaging,
 python3-pip <!nocheck>,
 python3-pkginfo <!nocheck>,
 python3-myst-parser <!nodoc>,
 python3-setuptools,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
 python3-sphinx-design <!nodoc>,
 python3-sphinxcontrib.qthelp <!nodoc>,
 python3-wheel,
 qml6-module-qtqml-workerscript (>= 6.10) <!nocheck>,
 qml6-module-qtquick (>= 6.10) <!nocheck>,
 qml6-module-qtquick-controls (>= 6.10) <!nocheck>,
 qml6-module-qtquick-layouts (>= 6.10) <!nocheck>,
 qml6-module-qtquick-templates (>= 6.10) <!nocheck>,
 qml6-module-qtquick-window (>= 6.10) <!nocheck>,
 qt6-3d-dev (>= 6.10),
 qt6-base-dev (>= 6.10),
 qt6-base-private-dev (>= 6.10),
 qt6-charts-dev (>= 6.10),
 qt6-connectivity-dev (>= 6.10) [linux-any],
 qt6-datavis3d-dev (>= 6.10),
 qt6-declarative-dev (>= 6.10),
 qt6-declarative-private-dev (>= 6.10),
 qt6-graphs-dev (>= 6.10),
 qt6-httpserver-dev (>= 6.10),
 qt6-location-dev (>= 6.10),
 qt6-multimedia-dev (>= 6.10),
 qt6-networkauth-dev (>= 6.10),
 qt6-pdf-dev (>= 6.10) [amd64 arm64 armhf i386],
 qt6-pdf-private-dev (>= 6.10) [amd64 arm64 armhf i386],
 qt6-positioning-dev (>= 6.10),
 qt6-qmllint-plugins (>= 6.10),
 qt6-qmltooling-plugins (>= 6.10),
 qt6-quick3d-dev (>= 6.10),
 qt6-remoteobjects-dev (>= 6.10),
 qt6-remoteobjects-private-dev (>= 6.10),
 qt6-scxml-dev (>= 6.10),
 qt6-sensors-dev (>= 6.10),
 qt6-serialbus-dev (>= 6.10),
 qt6-serialport-dev (>= 6.10),
 qt6-shadertools-dev (>= 6.10),
 qt6-speech-dev (>= 6.10),
 qt6-svg-dev (>= 6.10),
 qt6-tools-dev (>= 6.10),
 qt6-virtualkeyboard-dev (>= 6.10),
 qt6-wayland-dev (>= 6.10) [linux-any],
 qt6-webchannel-dev (>= 6.10),
 qt6-webengine-dev (>= 6.10) [amd64 arm64 armhf i386],
 qt6-websockets-dev (>= 6.10),
 qt6-webview-dev (>= 6.10) [amd64 arm64 armhf i386],
 qtchooser,
 sip-tools (>= 6.5),
 xauth <!nocheck>,
 xvfb <!nocheck>,
Build-Conflicts:
 libpyside6-dev,
 libshiboken6-dev,
Standards-Version: 4.7.3
Homepage: https://wiki.qt.io/Qt_for_Python
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt6/pyside6.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt6/pyside6

Package: libpyside6-dev
Section: libdevel
Architecture: any
Depends:
 libpyside6-py3-6.10 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 (development files)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package provides the development headers for the libpyside6 library.

Package: libpyside6-py3-6.10
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 libpyside6-py3-6.2,
 libpyside6-py3-6.4,
 libpyside6-py3-6.6,
 libpyside6-py3-6.7,
 libpyside6-py3-6.8,
 libpyside6-py3-6.9,
Replaces:
 libpyside6-py3-6.2,
 libpyside6-py3-6.4,
 libpyside6-py3-6.6,
 libpyside6-py3-6.7,
 libpyside6-py3-6.8,
 libpyside6-py3-6.9,
Provides:
 libpyside6-py3,
Description: Python 3 bindings for Qt 6 (base files)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python3 base file used by all modules.

Package: libshiboken6-dev
Section: libdevel
Architecture: any
Depends:
 libshiboken6-py3-6.10 (= ${binary:Version}),
 python3-dev,
 shiboken6 (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: CPython bindings generator for C++ libraries (development files)
 Shiboken6 is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 Shiboken6 is the binding generator used to create the PySide6 bindings.
 .
 This package provides the development headers for the libshiboken6 library.

Package: libshiboken6-py3-6.10
Section: libs
Architecture: any
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 libshiboken6-py3-6.2,
 libshiboken6-py3-6.4,
 libshiboken6-py3-6.6,
 libshiboken6-py3-6.7,
 libshiboken6-py3-6.8,
 libshiboken6-py3-6.9,
Replaces:
 libshiboken6-py3-6.2,
 libshiboken6-py3-6.4,
 libshiboken6-py3-6.6,
 libshiboken6-py3-6.7,
 libshiboken6-py3-6.8,
 libshiboken6-py3-6.9,
Provides:
 libshiboken6-py3,
Description: CPython bindings generator for C++ libraries (Python3 shared library)
 Shiboken6 is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 Shiboken6 is the binding generator used to create the PySide6 bindings.
 .
 This package contains the shared Python 3 library used by shiboken6.

Package: pyside6-tools
Architecture: any
Section: devel
Depends:
 python3-pyside6.qtcore,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: development tools for PySide6 (lupdate)
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 PySide6 ships Python bindings for the Qt 6 framework. This package ships
 the following accompanying tools:
  * pyside6-lupdate - update Qt Linguist translation files for PySide

Package: python-pyside6-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Multi-Arch: foreign
Description: Python bindings for Qt 6 (common documentation)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the common documentation package.

Package: python3-pyside6.qt3danimation
Architecture: any
Depends:
 python3-pyside6.qt3dcore,
 python3-pyside6.qt3drender,
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 python3-pyside6.qtnetwork,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DAnimation module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DAnimation module.

Package: python3-pyside6.qt3dcore
Architecture: any
Depends:
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 python3-pyside6.qtnetwork,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DCore module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DCore module.

Package: python3-pyside6.qt3dextras
Architecture: any
Depends:
 python3-pyside6.qt3dcore,
 python3-pyside6.qt3drender,
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 python3-pyside6.qtnetwork,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DExtras module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DExtras module.

Package: python3-pyside6.qt3dinput
Architecture: any
Depends:
 python3-pyside6.qt3dcore,
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DInput module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DInput module.

Package: python3-pyside6.qt3dlogic
Architecture: any
Depends:
 python3-pyside6.qt3dcore,
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DLogic module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DLogic module.

Package: python3-pyside6.qt3drender
Architecture: any
Depends:
 python3-pyside6.qt3dcore,
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 python3-pyside6.qtopengl,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 3DRender module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the Qt3DRender module.

Package: python3-pyside6.qtasyncio
Architecture: any
Depends:
 python3-pyside6.qtcore,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 ASyncIO (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the QtAsyncio module.

Package: python3-pyside6.qtbluetooth
Architecture: linux-any
Depends:
 python3-pyside6.qtcore,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 Bluetooth (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the QtBluetooth module.

Package: python3-pyside6.qtcharts
Architecture: any
Depends:
 python3-pyside6.qtcore,
 python3-pyside6.qtgui,
 python3-pyside6.qtwidgets,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 Charts module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the QtCharts module.

Package: python3-pyside6.qtconcurrent
Architecture: any
Depends:
 python3-pyside6.qtcore,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for Qt 6 Concurrent module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains Python 3 bindings for the QtConcurrent module.

Package: python3-pyside6.qtcore
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 python-pyside6-doc,
Description: Python bindings for Qt 6 core module (Python 3)
 pyside6 provides Python bindings for Qt 6.x framework.
 .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# Safety measure to ensure package names match SONAMEs
export PYSIDE_MAJOR := $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d. -f1-2)
ifeq ($(shell awk '/Package:/ {print $$2}' debian/control | grep -- -$(PYSIDE_MAJOR)$$),)
    $(error Please update package names for major version $(PYSIDE_MAJOR))
endif
ifeq ($(shell ls debian/lib* | grep -- -$(PYSIDE_MAJOR)),)
    $(error Please update files debian/lib*.* for major version $(PYSIDE_MAJOR))
endif

# don't set PYBUILD_NAME because we want the installed files to land in
# debian/tmp and then get split up into the feature packages.
export PYBUILD_SYSTEM = distutils

export MAIN_VERSION_UPSTREAM := $(shell echo $(DEB_VERSION_UPSTREAM))
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Add CPPFLAGS to CXXFLAGS as CMake ignores CPPFLAGS by default
CXXFLAGS+=$(CPPFLAGS)

export LLVM_INSTALL_DIR := $(shell llvm-config --prefix)

# Work around buildd bug (https://bugs.debian.org/842565)
undefine XDG_RUNTIME_DIR

PYBUILD_CONFIGURE_ARGS = --verbose
PYBUILD_BUILD_ARGS = --skip-packaging --verbose-build
PYBUILD_BUILD_ARGS += --parallel=$(or $(DEB_BUILD_OPTION_PARALLEL),$(DEB_BUILD_OPTION_PARALLEL),1)
PYBUILD_INSTALL_ARGS = --reuse-build --verbose-build

## Package compilation options

# 1. if sccache is installed then use it

SCCACHE := $(shell command -v sccache 2> /dev/null)

ifdef SCCACHE
  SCCACHE_DIR ?= $(HOME)/.cache/sccache
  export SCCACHE_DIR
  PYBUILD_BUILD_ARGS += --compiler-launcher=sccache
execute_before_dh_auto_build:
	-sccache --start-server
endif

# 2. support 'nocheck' builds - building and running the tests is slow
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  PYBUILD_BUILD_ARGS += --build-tests
endif

# 3. support 'nodoc' builds - building the docs just needs lots of extra deps
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
  PYBUILD_BUILD_ARGS += --build-docs
endif


export PYBUILD_BUILD_ARGS
export PYBUILD_INSTALL_ARGS



%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_build:
	# Record build in build index for test runner
	TODAY=`date -Id`; \
	mkdir -p build_history/$$TODAY; \
	echo $$PWD > build_history/$$TODAY/build_dir.txt; \
	py3versions -d >> build_history/$$TODAY/build_dir.txt

execute_after_dh_auto_install:
	# Obtain a list of files built to make it easier to update *.install files.
	# dh_missing will check all the install files at the end
	echo ">>> In build"
	-find build
	echo ">>> In debian/tmp"
	-find debian/tmp

override_dh_makeshlibs:
	dh_makeshlibs -VUpstream-Version

override_dh_installdocs-indep:
	dh_installdocs -X.doctrees

execute_after_dh_install-arch:
	# remove extra copies of documentation
	rm -rf $(CURDIR)/debian/libshiboken6-py3-*/usr/lib/python*/dist-packages/shiboken6/docs/
	# remove files from library package that are also in -dev package
	rm -rf $(CURDIR)/debian/libshiboken6-py3-*/usr/lib/python*/dist-packages/shiboken6_generator/lib/
	rm -rf $(CURDIR)/debian/libshiboken6-py3-*/usr/lib/python*/dist-packages/shiboken6/include
	# remove RUNPATH from libraries and executables
	# only look at files not symlinks
	find $(CURDIR)/debian/*/usr/lib/ -name \*.so* -type f -exec chrpath -d {} \;
	chrpath -d \
	  $(CURDIR)/debian/*/usr/lib/python3*/dist-packages/PySide6/Qt/libexec/*
	chrpath -d \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/assistant \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/balsam \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/balsamui \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/designer \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/linguist \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/lrelease \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/lupdate \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/qmlformat \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/qmllint \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/qmlls \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/qsb \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/PySide6/svgtoqml \
	  $(CURDIR)/debian/*/usr/lib/python*/dist-packages/shiboken6_generator/shiboken6

	# remove executable permissions
	find $(CURDIR)/debian/pyside6-tools/usr/lib/python3*/dist-packages/PySide6/scripts/ -type f -exec chmod a-x {} +

	# fix up various paths in .pc, cmake and __init__.py
	debian/set-paths

	# Make man pages for tools
	#./debian/make-manpages

execute_after_dh_python3:
	find $(CURDIR)/debian -name __pycache__ -type d -exec rm -rf {} +

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (mips64el,$(DEB_HOST_ARCH))
	# See https://bugs.debian.org/868745
	PIP_BREAK_SYSTEM_PACKAGES=1 \
	QSG_NO_DEPTH_BUFFER=1 xvfb-run -a dh_auto_test -- --system=custom \
		--test-args '{interpreter} testrunner.py test --buildno=-1'
else
	PIP_BREAK_SYSTEM_PACKAGES=1 \
	QTWEBENGINE_CHROMIUM_FLAGS="--disable-gpu --no-sandbox" \
	xvfb-run -a dh_auto_test -- --system=custom \
		--test-args '{interpreter} testrunner.py test --buildno=-1'
endif
endif
